﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AIShooter : MonoBehaviour
{

    public float shootRadius_ = 10.0f;

    public float restDuration_ = 10.0f;
    public float mineDuration_ = 10.0f;

    private float mineCounter_ = 0.0f;
    private float restCounter_ = 0.0f;

    // Start is called before the first frame update
    void Start()
    {
        GetComponent<LineRenderer>().SetVertexCount(2);
    }

    bool mineClosest(float amount)
    {
        amount = amount * 1.5f;
        GameObject closest = getClosestObject();

        if (closest == null)
        {
            GetComponent<LineRenderer>().enabled = false;
            return false;
        }

        GetComponent<LineRenderer>().enabled = true;

        GetComponent<LineRenderer>().SetPosition(0, transform.position);
        GetComponent<LineRenderer>().SetPosition(1, closest.transform.position);

        if (closest.tag == "asteroid")
        {
            closest.GetComponent<AsteroidBehaviour>().mine(amount);
        }
        else if (closest.tag == "Damageable")
        {
            closest.GetComponentInParent<HealthSystem>().TakeDamage(amount);
        }

        return true;
    }

    // Update is called once per frame
    void Update()
    {
        float time = Time.deltaTime;

        // rest
        if (mineCounter_ > mineDuration_)
        {
            GetComponent<LineRenderer>().enabled = false;
            restCounter_ += time;

            if (restCounter_ > restDuration_)
            {
                restCounter_ -= restDuration_;
                mineCounter_ -= mineDuration_;
            }
        }
        else // mine
        {
            if (mineClosest(time))
            {

                mineCounter_ += time;
            }
        }
    }

    GameObject getClosestObject()
    {
        Collider[] colliders = Physics.OverlapSphere(transform.position, shootRadius_);
        Collider closestCollider = null;
        foreach (Collider hit in colliders)
        { 
            //checks if it's hitting itself
            if(hit.GetComponent<Collider>() == GetComponent<Collider>())
            {
                continue;
            }

            if (hit.gameObject.tag != "asteroid" &&
                hit.gameObject.tag != "Damageable")
            {
                continue;
            }

            if (closestCollider == null)
            {
                closestCollider = hit;
            }


            //compares distances
            if(Vector3.Distance(transform.position, hit.transform.position) <= Vector3.Distance(transform.position, closestCollider.transform.position))
            {
                closestCollider = hit;
            }
        }

        if (closestCollider == null)
        {
            return null;
        }
        return closestCollider.gameObject;
    }
}
