﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AsteroidBehaviour : MonoBehaviour
{
    [SerializeField] int magmaValue;
    [SerializeField] int metalValue;
    [SerializeField] int pMetalValue;
    [SerializeField] int damageDoneOnCollision;

    [SerializeField] ParticleSystem poofParticle;
    [SerializeField] ParticleSystem explosionParticle;

    private float miningHealth = 2.0f;

    [SerializeField] int[] magmaValues;
    [SerializeField] int[] metalValues;
    [SerializeField] int[] pMetalValues;

    [SerializeField] bool spawnedByPlayer = false;


    public bool win_ = false;

    // Start is called before the first frame update

    // Update is called once per frame
    void Update()
    {
        
    }

    void Start() 
    {
        if(!spawnedByPlayer)
        {
            magmaValue = GetRandomDropValues(magmaValues);
        metalValue = GetRandomDropValues(metalValues);
        pMetalValue = GetRandomDropValues(pMetalValues);
        }
        
    }

    int GetRandomDropValues(int[] _array)
    {
        int rnd = Random.Range(0, _array.Length -1);
        int newVal = _array[rnd];
        return newVal;
    }

    public void mine(float amount)
    {
        miningHealth -= amount;
        if (miningHealth < 0.0f)
        {
            gameObject.SetActive(false);
        }
    }

    private void OnCollisionEnter(Collision other) 
    {
        if(other.collider.CompareTag("Damageable") && !win_) // Pelaajan "ulkokuori"
        {
            other.gameObject.GetComponent<HealthSystem>().TakeDamage(damageDoneOnCollision);
            //Destroy(this.gameObject);
            Instantiate(poofParticle, transform.position, transform.rotation);
            gameObject.SetActive(false);
            Debug.Log("Oh noes :(");

            // spawnataan pienet osat
            // äänet?
            // partikkelit?
        }

        if(other.collider.CompareTag("Enemy")) // player projectile, damage enemy
        {
            other.gameObject.GetComponent<SpawnScrap>().InstantiateScrap();
            Instantiate(explosionParticle, transform.position, transform.rotation);
            other.gameObject.SetActive(false);
        }
    }

    private void OnTriggerEnter(Collider other)
    {
        if(other.CompareTag("AsteroidCatcher")) // sisäpuoli 
        {
            if (win_)
            {
                print("We win!");
                GameObject.FindObjectOfType<UiManager>().ShowEndGameScreen();
            }

            Debug.Log("We caught an asteroid!");
            
            PlayerResources _pResources = other.transform.parent.parent.GetComponent<PlayerResources>();
            _pResources.MagmaStored += magmaValue;
            _pResources.CommonMetalStored += metalValue;
            _pResources.PreciousMetalStored += pMetalValue;


            other.GetComponent<Jaws>().CloseJaws();
            Instantiate(poofParticle, transform.position, transform.rotation);
            //Destroy(this.gameObject);
            gameObject.SetActive(false);
            
        }
    }
}
