﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HealthSystem : MonoBehaviour
{
    float currentHealth;
    [SerializeField] float maxHealth;
    float healthPercentage;
    [SerializeField] bool destroyOnDeath = false;
    [SerializeField] UiManager uiScript;


    public bool indestructable = false;

    // Start is called before the first frame update
    void Start()
    {
        currentHealth = maxHealth;
        uiScript.UpdateHullValueSlider(1f);
    }


    public void TakeDamage(float dmg)
    {
        if(currentHealth > 0 && !indestructable)
        {
            currentHealth -= dmg;
            healthPercentage = currentHealth / maxHealth;
            uiScript.UpdateHullValueSlider(healthPercentage);
            if(currentHealth <=0)
            {
                if(destroyOnDeath)
                {
                    gameObject.SetActive(false);
                    uiScript.ShowEndGameScreen();
                    //Destroy(this.gameObject);
                }
            }
        }
    }

    public void Repair(float repairvalue)
    {
        if(currentHealth < maxHealth)
        {
            currentHealth += repairvalue;
            
            if(currentHealth >= maxHealth)
            {
                currentHealth = maxHealth;
            }
            healthPercentage = currentHealth / maxHealth;
            uiScript.UpdateHullValueSlider(healthPercentage);
        }
    }

    public void repairToFull()
    {
        currentHealth = maxHealth;
        healthPercentage = currentHealth / maxHealth;
        uiScript.UpdateHullValueSlider(healthPercentage);
    }


    private void OnCollisionEnter(Collision other) 
    {
        if(other.gameObject.CompareTag("asteroid") && this.CompareTag("Damageable"))
        {
            //TakeDamage(1);

            // spawnataan pienemmät asteroidin osat?
            // pieni partikkeliefekti?
            //Destroy(other.gameObject);
        }
    }
}
