﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerResources : MonoBehaviour
{
    [SerializeField] int _magmaStored;
    [SerializeField] int _commonMetalStored;
    [SerializeField] int _preciousMetalStored;
    [SerializeField] UiManager uiScript;

    public bool canCollectPrecious_ = false;

    public int PreciousMetalStored
    {
        get{return _preciousMetalStored; } 
        set
        {
            if(value != 0 && canCollectPrecious_)
            {
                _preciousMetalStored = value; 
                uiScript.UpdatePreciousMetalText(_preciousMetalStored);
                uiScript.DisplayResourcePopUp(2);
            }
            
        }
    }

    public int MagmaStored
    {
        get{return _magmaStored; } 
        set
        {
            if(value > _magmaStored)
            {
                uiScript.DisplayResourcePopUp(0);
            }
            _magmaStored = value; 
            uiScript.UpdateMagmaText(_magmaStored);
            
            
        }
    }

    public int CommonMetalStored
    {
        get{return _commonMetalStored; } 
        set
        {
            if(value !=0)
            {
                _commonMetalStored = value; 
                uiScript.UpdateMetalText(_commonMetalStored);
                uiScript.DisplayResourcePopUp(1);
            }
            
        }
    }

    public bool consumeResources(int magma, int common, int precious)
    {
        if (_magmaStored >= magma && _commonMetalStored >= common & _preciousMetalStored >= precious)
            {
            _magmaStored -= magma;
            _commonMetalStored -= common;
            _preciousMetalStored -= precious;

            updateResourceUI();

            print("Level Up");
            return true;
        }

        return false;
    }


    public void updateResourceUI()
    {
        uiScript.UpdateMagmaText(_magmaStored);
        uiScript.UpdateMetalText(_commonMetalStored);
        uiScript.UpdatePreciousMetalText(_preciousMetalStored);
    }

}
