﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShipSpawner : MonoBehaviour
{
    public GameObject ship_ = null;

    public int level0ShipCount = 0;
    public int level1ShipCount = 2;
    public int level2ShipCount = 4;
    public int level3ShipCount = 5;

    private int maxRotation_ = 360;


    // Start is called before the first frame update
    void Start()
    {
        if (ship_ == null)
        {
            Debug.LogError("SET SHIP FOR SHIPSPAWNER");
            return;
        }

    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public List<GameObject> createShips(Vector2 min, Vector2 max, Vector3 position, int level)
    {
        if (ship_ == null)
        {
            Debug.LogError("SET SHIP FOR SHIPSPAWNER");
            return new List<GameObject>();
        }

        int numberOfShips = 0;

        switch (level)
        {
            case 0:
                numberOfShips = level0ShipCount;
                break;
            case 1:
                numberOfShips = level1ShipCount;
                break;
            case 2:
                numberOfShips = level2ShipCount;
                break;
            case 3:
                numberOfShips = level3ShipCount;
                break;
        }
        List<GameObject> ships = new List<GameObject>();
        for (int i = 0; i < numberOfShips; ++i)
        {
            float xPos = Random.Range(min.x, max.x);
            float yPos = Random.Range(min.y, max.y);

            float zRot = Random.Range(-maxRotation_, maxRotation_);

            GameObject newShip = GameObject.Instantiate(ship_);
            newShip.transform.position = new Vector3(xPos, yPos, 0) + position;

            newShip.GetComponent<ShipMovement>().setDirection(new Vector3(0, 0, zRot));

            ships.Add(newShip);
        }

        return ships;
    }
}
