﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class UiManager : MonoBehaviour
{
    [SerializeField] Text magmaText;
    [SerializeField] Text metalText;
    [SerializeField] Text preciousMetalText;
    [SerializeField] Image hullValue;

    [SerializeField] GameObject[] resourcePopups;

    [SerializeField] GameObject endGameScreen;
    public GameObject winScreen;

    private int commonMax_ = 0;
    public int preciousMax_ = 0;

    public Vector2 popupOffset;

    public void setCommonMax(int commonMax)
    {
        commonMax_ = commonMax;
    }


    // Start is called before the first frame update
    void Start()
    {
        
    }

    void Update() 
    {
        if(Input.GetKeyDown(KeyCode.Escape))
        {
            SceneManager.LoadScene(0);
        }
    }

    public void ShowEndGameScreen()
    {
        endGameScreen.SetActive(true);
    }
     public void ShowWinScreen()
    {
        winScreen.SetActive(true);
    }

    public IEnumerator ResourcePopupSequence(int res) // 0= magma 1= cmetal 2= pmetal
    {
        resourcePopups[res].SetActive(true);
        yield return new WaitForSeconds(.75f);
        resourcePopups[res].SetActive(false);
    }

    public void DisplayResourcePopUp(int res)
    {
        StartCoroutine(ResourcePopupSequence(res));
    }


    public void UpdateMagmaText(int magma)
    {
        magmaText.text = magma.ToString();
    }

    public void UpdateMetalText(int metal)
    {
        metalText.text = metal.ToString() + "/" + commonMax_.ToString();
    }

    public void UpdatePreciousMetalText(int pMetal)
    {
        preciousMetalText.text = pMetal.ToString() + "/" + preciousMax_.ToString();
    }
    public void UpdateHullValueSlider(float val)
    {
        Debug.Log("Updating the values");
        hullValue.fillAmount = val;
        if(val <= 0)
        {
            hullValue.fillAmount = 0f;
        }
    }
}
